// HelloDX10.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "HelloDX10.h"
#include <d3dx10.h>

#define MAX_LOADSTRING 100
#pragma comment( lib, "d3d10.lib" )
#pragma comment( lib, "d3dx10.lib" )

// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX
HWND  g_hWindow;

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

struct Vertex {
    D3DXVECTOR3 Pos;
    DWORD       Color;
};

int APIENTRY _tWinMain(HINSTANCE hInstance,
                       HINSTANCE hPrevInstance,
                       LPTSTR    lpCmdLine,
                       int       nCmdShow)
{
    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);

    // TODO: ɃR[h}ĂB
    MSG msg;
    HACCEL hAccelTable;

    // O[oĂ܂B
    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
    LoadString(hInstance, IDC_HELLODX10, szWindowClass, MAX_LOADSTRING);
    MyRegisterClass(hInstance);

    // AvP[V̏s܂:
    if (!InitInstance (hInstance, nCmdShow))
    {
        return FALSE;
    }

    hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_HELLODX10));

    // DirectX
    DXGI_SWAP_CHAIN_DESC sd;
    ZeroMemory( &sd, sizeof(sd) );
    sd.BufferCount = 1;
    sd.BufferDesc.Width = 640;
    sd.BufferDesc.Height = 480;
    sd.BufferDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
    sd.BufferDesc.RefreshRate.Numerator = 60;
    sd.BufferDesc.RefreshRate.Denominator = 1;
    sd.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
    sd.OutputWindow = g_hWindow;
    sd.SampleDesc.Count = 1;
    sd.SampleDesc.Quality = 0;
    sd.Windowed = TRUE;
    sd.Flags = DXGI_SWAP_CHAIN_FLAG_ALLOW_MODE_SWITCH;

    // C^[tF[X
    ID3D10Device* pDevice = 0;
    IDXGISwapChain* pSwapChain = 0;

    DWORD dwCreateFlags = D3D10_CREATE_DEVICE_DEBUG;
    HRESULT hr = D3D10CreateDeviceAndSwapChain( NULL, D3D10_DRIVER_TYPE_HARDWARE, NULL, dwCreateFlags, D3D10_SDK_VERSION, &sd, &pSwapChain, &pDevice );
    if( FAILED(hr) ) {
        OutputDebugStringA( "D3D10CreateDeviceAndSwapChain failed\n" );
    }

    ID3D10Texture2D* pBackBuffer = 0;
    ID3D10Texture2D* pDepthStencil = 0;
    ID3D10RenderTargetView* pRenderTargetView = 0;
    ID3D10DepthStencilView* pDepthStencilView = 0;
    hr = pSwapChain->GetBuffer( 0, __uuidof(ID3D10Texture2D), (LPVOID*)&pBackBuffer );
    if( FAILED(hr) ) {
        OutputDebugStringA( "pSwapChain->GetBuffer failed\n" );
    }
    hr = pDevice->CreateRenderTargetView( pBackBuffer, NULL, &pRenderTargetView );
    if( FAILED(hr) ) {
        OutputDebugStringA( "CreateRenderTargetView failed\n" );
    }
    if( pBackBuffer ) {
        pBackBuffer->Release();
        pBackBuffer = 0;
    }
    // fvXƃXeV
    D3D10_TEXTURE2D_DESC descDepth;
    ZeroMemory( &descDepth, sizeof(descDepth) );
    descDepth.Width = 640;
    descDepth.Height = 480;
    descDepth.MipLevels = 1;
    descDepth.ArraySize = 1;
    descDepth.Format = DXGI_FORMAT_D24_UNORM_S8_UINT;
    descDepth.SampleDesc.Count = 1;
    descDepth.SampleDesc.Quality = 0;
    descDepth.Usage = D3D10_USAGE_DEFAULT;
    descDepth.BindFlags = D3D10_BIND_DEPTH_STENCIL;
    hr = pDevice->CreateTexture2D( &descDepth, NULL, &pDepthStencil );
    
    D3D10_DEPTH_STENCIL_VIEW_DESC descDepthView;
    ZeroMemory( &descDepthView, sizeof(descDepthView) );
    descDepthView.Format = descDepth.Format;
    descDepthView.ViewDimension = D3D10_DSV_DIMENSION_TEXTURE2D;
    descDepthView.Texture2D.MipSlice = 0;
    pDevice->CreateDepthStencilView( pDepthStencil, &descDepthView, &pDepthStencilView );

    pDevice->OMSetRenderTargets( 1, &pRenderTargetView, pDepthStencilView );

    D3D10_VIEWPORT vp;
    vp.TopLeftX = 0;
    vp.TopLeftY = 0;
    vp.Width = 640;
    vp.Height = 480;
    vp.MinDepth = 0.0f;
    vp.MaxDepth = 1.0f;
    pDevice->RSSetViewports( 1, &vp );

    // \[X
    // 1. _obt@pӂ
    // 1.1 _obt@̂̂̐ݒ
    D3D10_BUFFER_DESC descVB;
    ZeroMemory( &descVB, sizeof(descVB) );
    descVB.Usage = D3D10_USAGE_DEFAULT;
    descVB.ByteWidth = sizeof(Vertex) * 3;
    descVB.BindFlags = D3D10_BIND_VERTEX_BUFFER;
    ID3D10Buffer* pVertexBuffer = 0;
    
    // _obt@ɑf[^
    Vertex vbdata[] = {
        { D3DXVECTOR3( 0.0f, 0.0f, 0.0f ), 0xffffffff },
        { D3DXVECTOR3( 1.0f, 0.0f, 0.0f ), 0xffff0000 },
        { D3DXVECTOR3( 0.0f,-1.0f, 0.0f ), 0xff00ff00 },
    };
    // 1.2 _obt@̒gɑ΂ݒ
    D3D10_SUBRESOURCE_DATA subdataVB;
    ZeroMemory( &subdataVB, sizeof(subdataVB) );
    subdataVB.pSysMem = vbdata;

    // 1.3 _obt@̍쐬
    hr = pDevice->CreateBuffer( &descVB, &subdataVB, &pVertexBuffer );

    // _VF[_[̏
    ID3D10Blob* pBlobVS = 0;
    ID3D10Blob* pErrMsg = 0;
    D3DX10CompileFromFile(
        L"shader.vs", NULL, NULL, "mainVS", "vs_4_0",
        D3D10_SHADER_ENABLE_STRICTNESS| D3D10_SHADER_PACK_MATRIX_COLUMN_MAJOR,
        0, NULL, &pBlobVS, &pErrMsg, &hr );
    if( pErrMsg ) {
        OutputDebugStringA( (const char*)pErrMsg->GetBufferPointer() );
        OutputDebugStringW( L"\n" );
        DebugBreak();
    }
    ID3D10VertexShader* pVertexShader = 0;
    pDevice->CreateVertexShader( pBlobVS->GetBufferPointer(), pBlobVS->GetBufferSize(), &pVertexShader );

    // sNZVF[_[̏
    ID3D10Blob* pBlobPS = 0;
    D3DX10CompileFromFile(
        L"shader.ps", NULL, NULL, "mainPS", "ps_4_0",
        D3D10_SHADER_ENABLE_STRICTNESS| D3D10_SHADER_PACK_MATRIX_COLUMN_MAJOR,
        0, NULL, &pBlobPS, &pErrMsg, &hr );
    if( pErrMsg ) {
        OutputDebugStringA( (const char*)pErrMsg->GetBufferPointer() );
        OutputDebugStringW( L"\n" );
        DebugBreak();
    }
    ID3D10PixelShader* pPixelShader = 0;
    pDevice->CreatePixelShader( pBlobPS->GetBufferPointer(), pBlobPS->GetBufferSize(), &pPixelShader );


    // _̗͂vf. 
    // ̓CAEgIuWFNg̓VF[_[̃oCgR[hv
    D3D10_INPUT_ELEMENT_DESC layout[] = {
        { "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D10_INPUT_PER_VERTEX_DATA, 0 },
        { "COLOR", 0, DXGI_FORMAT_R8G8B8A8_UNORM, 0, 12, D3D10_INPUT_PER_VERTEX_DATA, 0 },
    };
    ID3D10InputLayout* pInputLayout = 0;
    pDevice->CreateInputLayout( layout, 2, pBlobVS->GetBufferPointer(), pBlobVS->GetBufferSize(), &pInputLayout );

    // C bZ[W [v:
    do {
        if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
            if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
            {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
        } else {
            // NA
            float clearColor[4] = { 0.5f, 0.0f, 0.0f, 0.0f };
            pDevice->ClearRenderTargetView( pRenderTargetView, clearColor );
            pDevice->ClearDepthStencilView( pDepthStencilView, D3D10_CLEAR_DEPTH |D3D10_CLEAR_STENCIL, 1.0f, 0 );

            // obt@̃Zbg
            UINT strides[1] = { sizeof(Vertex) };
            UINT offsets[1] = { 0 };
            pDevice->IASetVertexBuffers( 0, 1, &pVertexBuffer, strides, offsets );
            pDevice->IASetPrimitiveTopology( D3D10_PRIMITIVE_TOPOLOGY_TRIANGLELIST );
            pDevice->IASetInputLayout( pInputLayout );

            // VF[_[̃Zbg
            pDevice->VSSetShader( pVertexShader );
            pDevice->PSSetShader( pPixelShader );

            // `
            pDevice->Draw( 3, 0 );


            pSwapChain->Present( 0, 0 );
        }
    } while( msg.message != WM_QUIT );

    if( pDevice ) {
        pDevice->ClearState();
    }
    pRenderTargetView->Release();
    pDepthStencilView->Release();
    pDepthStencil->Release();
    pSwapChain->Release();
    pDevice->Release();

    return (int) msg.wParam;
}



//
//  ֐: MyRegisterClass()
//
//  ړI: EBhE NXo^܂B
//
//  Rg:
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//    Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
    WNDCLASSEX wcex;

    wcex.cbSize = sizeof(WNDCLASSEX);

    wcex.style			= CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc	= WndProc;
    wcex.cbClsExtra		= 0;
    wcex.cbWndExtra		= 0;
    wcex.hInstance		= hInstance;
    wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_HELLODX10));
    wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_HELLODX10);
    wcex.lpszClassName	= szWindowClass;
    wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

    return RegisterClassEx(&wcex);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI: CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;

    hInst = hInstance; // O[oϐɃCX^Xi[܂B

    RECT rc = { 0, 0, 640, 480 };
    AdjustWindowRect( &rc, WS_OVERLAPPEDWINDOW, TRUE );
    hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW, 
        CW_USEDEFAULT, 0, rc.right - rc.left, rc.bottom-rc.top, NULL, NULL, hInstance, NULL );

    if (!hWnd)
    {
        return FALSE;
    }

    g_hWindow = hWnd;
    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

    return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI:  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;

    switch (message)
    {
    case WM_COMMAND:
        wmId    = LOWORD(wParam);
        wmEvent = HIWORD(wParam);
        // Iꂽj[̉:
        switch (wmId)
        {
        case IDM_EXIT:
            DestroyWindow(hWnd);
            break;
        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
        }
        break;
    case WM_PAINT:
        hdc = BeginPaint(hWnd, &ps);
        // TODO: `R[hɒǉĂ...
        EndPaint(hWnd, &ps);
        break;
    case WM_DESTROY:
        PostQuitMessage(0);
        break;
    default:
        return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}
